from flexprice import Flexprice
with Flexprice(
api_key_auth="<YOUR_API_KEY_HERE>",
) as f_client:
res = f_client.invoices.update_invoice_payment_status(id="<id>", payment_status="INITIATED")
# Handle response
print(res)
import { Flexprice } from "@flexprice/sdk";
const flexprice = new Flexprice({
apiKeyAuth: "<YOUR_API_KEY_HERE>",
});
async function run() {
const result = await flexprice.invoices.updateInvoicePaymentStatus("<id>", {
paymentStatus: "INITIATED",
});
console.log(result);
}
run();
from flexprice import Flexprice
with Flexprice(
api_key_auth="<YOUR_API_KEY_HERE>",
) as f_client:
res = f_client.invoices.update_invoice_payment_status(id="<id>", payment_status="INITIATED")
# Handle response
print(res)
import { Flexprice } from "@flexprice/sdk";
const flexprice = new Flexprice({
apiKeyAuth: "<YOUR_API_KEY_HERE>",
});
async function run() {
const result = await flexprice.invoices.updateInvoicePaymentStatus("<id>", {
paymentStatus: "INITIATED",
});
console.log(result);
}
run();
adjustment_amount is the total sum of credit notes of type "adjustment".
These are non-cash reductions applied to the invoice (e.g. goodwill credit, billing correction).
is_manually_edited is true once a user has manually added, edited, or removed a line item on this draft invoice.
Once set, automated recomputation of this invoice's line items must no-op rather than overwrite the manual edit.
recalculated_invoice_id is the ID of the replacement invoice created when this invoice was voided and recalculated.
When set, it forms a parent→child link from this (voided) invoice to the new replacement invoice.
subscription_customer_id is the subscription owner's customer ID (Subscription.CustomerID).
It may differ from customer_id when the subscription uses an invoicing customer. Set internally; nullable in DB.
voided_at is the timestamp when this invoice was voided or cancelled
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Flexprice","colors":{"primary":"#15547c","light":"#2580b5","dark":"#134a6b"},"logo":{"light":"https://mintcdn.com/flexprice/Qokjirde4CQUcFy8/images/FlexpriceWordMarkDark.png?fit=max\u0026auto=format\u0026n=Qokjirde4CQUcFy8\u0026q=85\u0026s=d706a1b6139418c2d57ba902fb0b6de4","dark":"https://mintcdn.com/flexprice/Qokjirde4CQUcFy8/images/FlexpriceWordMarkLight.png?fit=max\u0026auto=format\u0026n=Qokjirde4CQUcFy8\u0026q=85\u0026s=3fe3d9881552f4ebecb6f6aa7cfe2f66"},"favicon":"https://mintcdn.com/flexprice/Qokjirde4CQUcFy8/doc.png?fit=max\u0026auto=format\u0026n=Qokjirde4CQUcFy8\u0026q=85\u0026s=7e9ab0952b828b96d03f9298571462a4","api":{"examples":{"languages":["curl","python","typescript","go"]}},"background":{"decoration":"gradient","color":{"light":"#fffdf8","dark":"#010b13"}},"navbar":{"links":[],"primary":{"type":"button","label":"Dashboard","href":"https://admin.flexprice.io/"}},"footer":{"socials":{"github":"https://github.com/flexprice/flexprice","linkedin":"https://www.linkedin.com/company/flexpriceio","website":"https://flexprice.io/","x":"https://x.com/tryflexprice"}},"fonts":{"family":"Geist"},"integrations":{"ga4":{"measurementId":"G-9RV8NDCXNN"}},"contextual":{"options":["copy","view","chatgpt","claude"],"display":"header"},"styling":{"latex":true},"navigation":{"global":{"anchors":[{"anchor":"Support","icon":"https://mintlify.s3.us-west-1.amazonaws.com/flexprice/images/anchors/mail.svg","href":"mailto:support@flexprice.io"},{"anchor":"Community","icon":"https://mintlify.s3.us-west-1.amazonaws.com/flexprice/images/anchors/slack.svg","href":"https://join.slack.com/t/flexpricecommunity/shared_invite/zt-39uat51l0-n8JmSikHZP~bHJNXladeaQ"},{"anchor":"Website","icon":"https://mintlify.s3.us-west-1.amazonaws.com/flexprice/images/anchors/flexprice.svg","href":"https://flexprice.io/"}]},"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"flexprice","hasAudioNarration":false,"actualSubdomain":"flexprice","customDomains":["docs.flexprice.io"],"gitSource":{"type":"github","owner":"flexprice","repo":"flexprice-docs","deployBranch":"main","contentDirectory":"","isPrivate":true,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6adb5c47a0e78eb4aee8f95c","collectionId":"da2d6ec5-0a60-46e2-9ea7-aff6d0cc5f88","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6adb5c47a0e78eb4aee8f95c"},"feedback":{"thumbs":false,"agentFeedback":true},"entitlements":{"AI_CHAT":{"status":"DISABLED"}},"buildId":"6adb5c47a0e78eb4aee8f95c","clientVersion":"0.0.3971","searchFilterCounts":[{"language":"default","tag":"API Reference","count":300},{"language":"default","tag":"Resources","count":297},{"language":"default","tag":"Developers","count":142},{"language":"default","tag":"Documentation","count":118},{"language":"default","tag":"Integrations","count":102},{"language":"default","tag":"Webhook Events","count":62},{"language":"default","tag":"Subscriptions","count":45},{"language":"default","tag":"CLI","count":38},{"language":"default","tag":"Command reference","count":34},{"language":"default","tag":"Pricing and Packaging","count":25}]},"assistantConfig":{"enableStarterQuestions":false,"deflection":{"enabled":true,"email":"support@flexprice.io","showHelpButton":true}},"basePath":"","hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"privacy":{"consentBanner":{"enabled":false}},"isAtlas":false,"googleFontsInlined":true},"customCss":[{"filePath":"style.css","content":"/* latin-ext */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 400;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu6-K6h9Q.woff2) format('woff2');\n unicode-range: U+0100-02BA, U+02BD-02C5, U+02C7-02CC, U+02CE-02D7, U+02DD-02FF, U+0304, U+0308, U+0329, U+1D00-1DBF, U+1E00-1E9F, U+1EF2-1EFF, U+2020, U+20A0-20AB, U+20AD-20C4, U+2113, U+2C60-2C7F, U+A720-A7FF;\n}\n/* latin */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 400;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu0-K4.woff2) format('woff2');\n unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+0304, U+0308, U+0329, U+2000-206F, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\n}\n/* latin-ext */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 500;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu6-K6h9Q.woff2) format('woff2');\n unicode-range: U+0100-02BA, U+02BD-02C5, U+02C7-02CC, U+02CE-02D7, U+02DD-02FF, U+0304, U+0308, U+0329, U+1D00-1DBF, U+1E00-1E9F, U+1EF2-1EFF, U+2020, U+20A0-20AB, U+20AD-20C4, U+2113, U+2C60-2C7F, U+A720-A7FF;\n}\n/* latin */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 500;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu0-K4.woff2) format('woff2');\n unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+0304, U+0308, U+0329, U+2000-206F, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\n}\n/* latin-ext */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 600;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu6-K6h9Q.woff2) format('woff2');\n unicode-range: U+0100-02BA, U+02BD-02C5, U+02C7-02CC, U+02CE-02D7, U+02DD-02FF, U+0304, U+0308, U+0329, U+1D00-1DBF, U+1E00-1E9F, U+1EF2-1EFF, U+2020, U+20A0-20AB, U+20AD-20C4, U+2113, U+2C60-2C7F, U+A720-A7FF;\n}\n/* latin */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 600;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu0-K4.woff2) format('woff2');\n unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+0304, U+0308, U+0329, U+2000-206F, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\n}\n/* latin-ext */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 700;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu6-K6h9Q.woff2) format('woff2');\n unicode-range: U+0100-02BA, U+02BD-02C5, U+02C7-02CC, U+02CE-02D7, U+02DD-02FF, U+0304, U+0308, U+0329, U+1D00-1DBF, U+1E00-1E9F, U+1EF2-1EFF, U+2020, U+20A0-20AB, U+20AD-20C4, U+2113, U+2C60-2C7F, U+A720-A7FF;\n}\n/* latin */\n@font-face {\n font-family: 'DM Sans';\n font-style: normal;\n font-weight: 700;\n font-display: swap;\n src: url(/_mintlify/assets/fonts/google/s/dmsans/v17/rP2Yp2ywxg089UriI5-g4vlH9VoD8Cmcqbu0-K4.woff2) format('woff2');\n unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+0304, U+0308, U+0329, U+2000-206F, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;\n}\nh1{font-family:'DM Sans',sans-serif;font-weight:700!important;letter-spacing:-.01em!important}.page-title,.section-title,.title,[data-title]{font-family:'DM Sans',sans-serif;font-weight:400;letter-spacing:.025em!important}.nav-logo{height:22px}[class*=Navbar] a[href*=\"admin.flexprice.io\"],[class*=nav] a[href*=\"admin.flexprice.io\"]{background-color:#134a6b!important;color:#fff!important;font-weight:500;border-radius:6px;padding:.5rem 1rem}[class*=Navbar] a[href*=\"admin.flexprice.io\"]:hover,[class*=nav] a[href*=\"admin.flexprice.io\"]:hover{background-color:#0d3d5c!important;color:#fff!important}.\\32xl\\:max-w-2xl,.content-area{max-width:50rem!important}.nav-anchor:hover>div{background-color:rgba(21,84,124,.08)!important}.dark .nav-anchor:hover>div{background-color:rgba(255,255,255,.08)!important}.nav-anchor img{background-color:transparent!important}.dark .nav-anchor img[src*=\"anchors/flexprice\"]{filter:brightness(0) invert(1)}"}],"page":{"pagePath":"api-reference/invoices/update-invoice-payment-status","slug":"/api-reference/invoices/update-invoice-payment-status","pageMetadata":{"title":"Update invoice payment status","description":"Use when reconciling payment status from an external gateway or manual entry (e.g. mark paid after bank confirmation).","deprecated":null,"version":null,"openapi":"https://swagger.flexprice.io put /invoices/{id}/payment","href":"/api-reference/invoices/update-invoice-payment-status","autogeneratedByOpenApi":true},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsx(_components.p, {\n children: \"Use when reconciling payment status from an external gateway or manual entry (e.g. mark paid after bank confirmation).\"\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Update invoice payment status","description":"Use when reconciling payment status from an external gateway or manual entry (e.g. mark paid after bank confirmation).","deprecated":null,"version":null,"openapi":"https://swagger.flexprice.io put /invoices/{id}/payment","href":"/api-reference/invoices/update-invoice-payment-status","autogeneratedByOpenApi":true}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":["/_mintlify/custom/flexprice/c6cd5bf06bcd0181/reo-tracking.js"],"openApiReferenceData":{"operation":{"tags":["Invoices"],"summary":"Update invoice payment status","description":"Use when reconciling payment status from an external gateway or manual entry (e.g. mark paid after bank confirmation).","operationId":"updateInvoicePaymentStatus","parameters":["1ed32475-c222-4276-8b9e-3630fd00fb1d"],"requestBody":"fa3737d0-9b56-4036-916d-97873feb577a","responses":{"200":"6c87c451-14bc-4eab-9c8d-9de46f4de9a5","400":"51970d7e-26cf-4471-9103-6f88c5c3557b","404":"32498f69-d1b5-4c96-a269-1fa16b05b2a7","500":"a2a0051b-8173-4cb2-bc02-902a94661270"},"security":["dc28e240-ca48-4347-adc2-7dfa47ac0f00"],"x-codegen-request-body-name":"request","x-codeSamples":[{"lang":"go","label":"Go","source":"package main\n\nimport(\n\t\"context\"\n\tflexprice \"github.com/flexprice/go-sdk/v2\"\n\t\"github.com/flexprice/go-sdk/v2/models/types\"\n\t\"log\"\n)\n\nfunc main() {\n ctx := context.Background()\n\n s := flexprice.New(\n flexprice.WithSecurity(\"\u003cYOUR_API_KEY_HERE>\"),\n )\n\n res, err := s.Invoices.UpdateInvoicePaymentStatus(ctx, \"\u003cid>\", types.UpdatePaymentStatusRequest{\n PaymentStatus: types.PaymentStatusInitiated,\n })\n if err != nil {\n log.Fatal(err)\n }\n if res.InvoiceResponse != nil {\n // handle response\n }\n}"},{"lang":"python","label":"Python","source":"from flexprice import Flexprice\n\n\nwith Flexprice(\n api_key_auth=\"\u003cYOUR_API_KEY_HERE>\",\n) as f_client:\n\n res = f_client.invoices.update_invoice_payment_status(id=\"\u003cid>\", payment_status=\"INITIATED\")\n\n # Handle response\n print(res)"},{"lang":"typescript","label":"TypeScript","source":"import { Flexprice } from \"@flexprice/sdk\";\n\nconst flexprice = new Flexprice({\n apiKeyAuth: \"\u003cYOUR_API_KEY_HERE>\",\n});\n\nasync function run() {\n const result = await flexprice.invoices.updateInvoicePaymentStatus(\"\u003cid>\", {\n paymentStatus: \"INITIATED\",\n });\n\n console.log(result);\n}\n\nrun();"}],"method":"put","type":"path","servers":["c3a552c0-fb0d-4192-bbfb-41d490814c91","8d9b0e10-8210-4fd4-9d91-5200cae97a59"],"path":"/invoices/{id}/payment","baseUrlOptions":["https://us.api.flexprice.io/v1","https://api.cloud.flexprice.io/v1"],"title":"Update invoice payment status","codeSamples":[{"label":"Go","lang":"go","source":"package main\n\nimport(\n\t\"context\"\n\tflexprice \"github.com/flexprice/go-sdk/v2\"\n\t\"github.com/flexprice/go-sdk/v2/models/types\"\n\t\"log\"\n)\n\nfunc main() {\n ctx := context.Background()\n\n s := flexprice.New(\n flexprice.WithSecurity(\"\u003cYOUR_API_KEY_HERE>\"),\n )\n\n res, err := s.Invoices.UpdateInvoicePaymentStatus(ctx, \"\u003cid>\", types.UpdatePaymentStatusRequest{\n PaymentStatus: types.PaymentStatusInitiated,\n })\n if err != nil {\n log.Fatal(err)\n }\n if res.InvoiceResponse != nil {\n // handle response\n }\n}"},{"label":"Python","lang":"python","source":"from flexprice import Flexprice\n\n\nwith Flexprice(\n api_key_auth=\"\u003cYOUR_API_KEY_HERE>\",\n) as f_client:\n\n res = f_client.invoices.update_invoice_payment_status(id=\"\u003cid>\", payment_status=\"INITIATED\")\n\n # Handle response\n print(res)"},{"label":"TypeScript","lang":"typescript","source":"import { Flexprice } from \"@flexprice/sdk\";\n\nconst flexprice = new Flexprice({\n apiKeyAuth: \"\u003cYOUR_API_KEY_HERE>\",\n});\n\nasync function run() {\n const result = await flexprice.invoices.updateInvoicePaymentStatus(\"\u003cid>\", {\n paymentStatus: \"INITIATED\",\n });\n\n console.log(result);\n}\n\nrun();"}],"requestExampleLanguages":["bash","python","typescript","go"],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"1ed32475-c222-4276-8b9e-3630fd00fb1d":{"name":"id","in":"path","description":"Invoice ID","required":true,"schema":{"type":"string","isRequired":true,"description":"Invoice ID","uniqueKey":"","typeLabel":"string"}}},"requestBody":{"description":"Payment Status Update Request","content":{"application/json":{"schema":{"required":["payment_status"],"type":"object","properties":{"payment_status":{"type":"string","enum":["INITIATED","PENDING","PROCESSING","SUCCEEDED","OVERPAID","FAILED","REFUNDED","PARTIALLY_REFUNDED","VOIDED"],"x-enum-varnames":["PaymentStatusInitiated","PaymentStatusPending","PaymentStatusProcessing","PaymentStatusSucceeded","PaymentStatusOverpaid","PaymentStatusFailed","PaymentStatusRefunded","PaymentStatusPartiallyRefunded","PaymentStatusVoided"],"x-speakeasy-name-override":"PaymentStatus","isRequired":true,"uniqueKey":"payment_status","typeLabel":"enum\u003cstring>"},"amount":{"type":"string","description":"amount is the optional payment amount to record","uniqueKey":"amount","typeLabel":"string"}},"uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"amount":"\u003cstring>"}}},"exampleType":"generated"}},"required":true,"exampleType":"generated"},"responses":{"6c87c451-14bc-4eab-9c8d-9de46f4de9a5":{"description":"OK","content":{"application/json":{"schema":{"type":"object","properties":{"adjustment_amount":{"type":"string","description":"adjustment_amount is the total sum of credit notes of type \"adjustment\".\nThese are non-cash reductions applied to the invoice (e.g. goodwill credit, billing correction).","uniqueKey":"adjustment_amount","typeLabel":"string"},"amount_due":{"type":"string","description":"amount_due is the total amount that needs to be paid for this invoice","uniqueKey":"amount_due","typeLabel":"string"},"amount_paid":{"type":"string","description":"amount_paid is the amount that has already been paid towards this invoice","uniqueKey":"amount_paid","typeLabel":"string"},"amount_remaining":{"type":"string","description":"amount_remaining is the outstanding amount still owed on this invoice (calculated as amount_due minus amount_paid)","uniqueKey":"amount_remaining","typeLabel":"string"},"billing_period":{"type":"string","description":"billing_period describes the billing period this invoice covers (e.g., \"January 2024\", \"Q1 2024\")","uniqueKey":"billing_period","typeLabel":"string"},"billing_reason":{"type":"string","description":"billing_reason indicates why this invoice was generated (e.g., \"subscription_billing\", \"manual_charge\")","uniqueKey":"billing_reason","typeLabel":"string"},"billing_sequence":{"type":"integer","description":"billing_sequence is the sequential number indicating the billing cycle for subscription invoices","uniqueKey":"billing_sequence","typeLabel":"integer"},"checkout_session":{"type":"object","properties":{"action":{"type":"string","enum":["create_subscription","modify_subscription","wallet_topup","add_addon","pay_invoice"],"x-enum-varnames":["CheckoutActionCreateSubscription","CheckoutActionModifySubscription","CheckoutActionWalletTopup","CheckoutActionAddAddon","CheckoutActionPayInvoice"],"x-speakeasy-name-override":"CheckoutAction","uniqueKey":"checkout_session.action","typeLabel":"enum\u003cstring>"},"cancel_url":{"type":"string","uniqueKey":"checkout_session.cancel_url","typeLabel":"string"},"cancelled_at":{"type":"string","format":"date-time","uniqueKey":"checkout_session.cancelled_at","typeLabel":"string\u003cdate-time>"},"checkout_invoice_id":{"type":"string","uniqueKey":"checkout_session.checkout_invoice_id","typeLabel":"string"},"checkout_payment_id":{"type":"string","uniqueKey":"checkout_session.checkout_payment_id","typeLabel":"string"},"checkout_status":{"type":"string","enum":["initiated","pending","completed","failed","expired"],"x-enum-varnames":["CheckoutStatusInitiated","CheckoutStatusPending","CheckoutStatusCompleted","CheckoutStatusFailed","CheckoutStatusExpired"],"x-speakeasy-name-override":"CheckoutStatus","uniqueKey":"checkout_session.checkout_status","typeLabel":"enum\u003cstring>"},"completed_at":{"type":"string","format":"date-time","uniqueKey":"checkout_session.completed_at","typeLabel":"string\u003cdate-time>"},"created_at":{"type":"string","format":"date-time","uniqueKey":"checkout_session.created_at","typeLabel":"string\u003cdate-time>"},"customer_id":{"type":"string","uniqueKey":"checkout_session.customer_id","typeLabel":"string"},"entity_creation_result":{"type":"object","properties":{"entity_id":{"type":"string","uniqueKey":"checkout_session.entity_creation_result.entity_id","typeLabel":"string"},"status":{"type":"string","enum":["created","superseded","failed_already_exists"],"x-enum-varnames":["EntityCreationStatusCreated","EntityCreationStatusSuperseded","EntityCreationStatusFailedAlreadyExists"],"x-speakeasy-name-override":"EntityCreationStatus","uniqueKey":"checkout_session.entity_creation_result.status","typeLabel":"enum\u003cstring>"}},"uniqueKey":"checkout_session.entity_creation_result","typeLabel":"object"},"expires_at":{"type":"string","format":"date-time","uniqueKey":"checkout_session.expires_at","typeLabel":"string\u003cdate-time>"},"failure_reason":{"type":"string","uniqueKey":"checkout_session.failure_reason","typeLabel":"string"},"failure_url":{"type":"string","uniqueKey":"checkout_session.failure_url","typeLabel":"string"},"id":{"type":"string","uniqueKey":"checkout_session.id","typeLabel":"string"},"idempotency_key":{"type":"string","uniqueKey":"checkout_session.idempotency_key","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"checkout_session.metadata.additionalProperties","typeLabel":"string"},"x-speakeasy-name-override":"Metadata","uniqueKey":"checkout_session.metadata","typeLabel":"object"},"next_poll_after_ms":{"type":"integer","description":"NextPollAfterMs is how long a client should wait before reading again.\nZero means stop — either the session is terminal, or this response did not\ncome from a polling read.","uniqueKey":"checkout_session.next_poll_after_ms","typeLabel":"integer"},"payment":{"type":"object","properties":{"gateway":{"type":"string","uniqueKey":"checkout_session.payment.gateway","typeLabel":"string"},"id":{"type":"string","uniqueKey":"checkout_session.payment.id","typeLabel":"string"},"status":{"type":"string","enum":["INITIATED","PENDING","PROCESSING","SUCCEEDED","OVERPAID","FAILED","REFUNDED","PARTIALLY_REFUNDED","VOIDED"],"x-enum-varnames":["PaymentStatusInitiated","PaymentStatusPending","PaymentStatusProcessing","PaymentStatusSucceeded","PaymentStatusOverpaid","PaymentStatusFailed","PaymentStatusRefunded","PaymentStatusPartiallyRefunded","PaymentStatusVoided"],"x-speakeasy-name-override":"PaymentStatus","uniqueKey":"checkout_session.payment.status","typeLabel":"enum\u003cstring>"}},"uniqueKey":"checkout_session.payment","typeLabel":"object"},"payment_action":{"type":"object","properties":{"type":{"type":"string","enum":["checkout_url","payment_link"],"x-enum-varnames":["PaymentActionTypeCheckoutURL","PaymentActionTypePaymentLink"],"x-speakeasy-name-override":"PaymentActionType","uniqueKey":"checkout_session.payment_action.type","typeLabel":"enum\u003cstring>"},"url":{"type":"string","uniqueKey":"checkout_session.payment_action.url","typeLabel":"string"}},"x-speakeasy-name-override":"PaymentAction","uniqueKey":"checkout_session.payment_action","typeLabel":"object"},"payment_provider":{"type":"string","enum":["razorpay","chargebee","stripe"],"x-enum-varnames":["CheckoutPaymentProviderRazorpay","CheckoutPaymentProviderChargebee","CheckoutPaymentProviderStripe"],"x-speakeasy-name-override":"CheckoutPaymentProvider","uniqueKey":"checkout_session.payment_provider","typeLabel":"enum\u003cstring>"},"stale":{"type":"boolean","description":"Stale reports that this response is stored state that was not checked against\nthe payment provider on this request — the read was debounced, or the gateway\ndid not answer. A UI should say \"still checking\" rather than presenting a\nstale answer as fact.","uniqueKey":"checkout_session.stale","typeLabel":"boolean"},"success_url":{"type":"string","uniqueKey":"checkout_session.success_url","typeLabel":"string"},"terminal":{"type":"boolean","description":"Terminal reports whether the session has finished. Clients poll until this is\ntrue rather than hardcoding the status set, which would go stale if a status\nis ever added.","uniqueKey":"checkout_session.terminal","typeLabel":"boolean"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"checkout_session.updated_at","typeLabel":"string\u003cdate-time>"}},"uniqueKey":"checkout_session","typeLabel":"object"},"coupon_applications":{"type":"array","description":"coupon_applications contains the coupon applications associated with this invoice (overrides embedded field)","items":{"type":"object","properties":{"applied_at":{"type":"string","format":"date-time","uniqueKey":"coupon_applications.items.[INDEX].applied_at","typeLabel":"string\u003cdate-time>"},"coupon_association_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].coupon_association_id","typeLabel":"string"},"coupon_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].coupon_id","typeLabel":"string"},"coupon_snapshot":{"type":"object","additionalProperties":true,"uniqueKey":"coupon_applications.items.[INDEX].coupon_snapshot","typeLabel":"object"},"created_at":{"type":"string","format":"date-time","uniqueKey":"coupon_applications.items.[INDEX].created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].created_by","typeLabel":"string"},"currency":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].currency","typeLabel":"string"},"discount_percentage":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].discount_percentage","typeLabel":"string"},"discount_type":{"type":"string","enum":["fixed","percentage"],"x-enum-varnames":["CouponTypeFixed","CouponTypePercentage"],"x-speakeasy-name-override":"CouponType","uniqueKey":"coupon_applications.items.[INDEX].discount_type","typeLabel":"enum\u003cstring>"},"discounted_amount":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].discounted_amount","typeLabel":"string"},"environment_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].environment_id","typeLabel":"string"},"final_price":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].final_price","typeLabel":"string"},"id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].id","typeLabel":"string"},"invoice_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].invoice_id","typeLabel":"string"},"invoice_line_item_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].invoice_line_item_id","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].metadata.additionalProperties","typeLabel":"string"},"uniqueKey":"coupon_applications.items.[INDEX].metadata","typeLabel":"object"},"original_price":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].original_price","typeLabel":"string"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"coupon_applications.items.[INDEX].status","typeLabel":"enum\u003cstring>"},"subscription_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].subscription_id","typeLabel":"string"},"tenant_id":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].tenant_id","typeLabel":"string"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"coupon_applications.items.[INDEX].updated_at","typeLabel":"string\u003cdate-time>"},"updated_by":{"type":"string","uniqueKey":"coupon_applications.items.[INDEX].updated_by","typeLabel":"string"}},"uniqueKey":"coupon_applications.items.[INDEX]","typeLabel":"object"},"uniqueKey":"coupon_applications","typeLabel":"object[]"},"created_at":{"type":"string","format":"date-time","uniqueKey":"created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"created_by","typeLabel":"string"},"currency":{"type":"string","description":"currency is the three-letter ISO currency code (e.g., USD, EUR, GBP) that applies to all monetary amounts on this invoice","uniqueKey":"currency","typeLabel":"string"},"custom_currency":{"type":"object","properties":{"amount_due":{"type":"string","uniqueKey":"custom_currency.amount_due","typeLabel":"string"},"code":{"type":"string","uniqueKey":"custom_currency.code","typeLabel":"string"},"rate":{"type":"string","description":"fiat per 1 unit of Code; the live factor while draft, frozen at finalization","uniqueKey":"custom_currency.rate","typeLabel":"string"},"subtotal":{"type":"string","uniqueKey":"custom_currency.subtotal","typeLabel":"string"},"total":{"type":"string","uniqueKey":"custom_currency.total","typeLabel":"string"},"total_discount":{"type":"string","uniqueKey":"custom_currency.total_discount","typeLabel":"string"},"total_prepaid_credits_applied":{"type":"string","uniqueKey":"custom_currency.total_prepaid_credits_applied","typeLabel":"string"},"total_tax":{"type":"string","uniqueKey":"custom_currency.total_tax","typeLabel":"string"}},"x-speakeasy-name-override":"CustomCurrency","uniqueKey":"custom_currency","typeLabel":"object"},"customer":{"type":"object","properties":{"address_city":{"type":"string","description":"AddressCity is the city of the customer's address","uniqueKey":"customer.address_city","typeLabel":"string"},"address_country":{"type":"string","description":"AddressCountry is the country of the customer's address (ISO 3166-1 alpha-2)","uniqueKey":"customer.address_country","typeLabel":"string"},"address_line1":{"type":"string","description":"AddressLine1 is the first line of the customer's address","uniqueKey":"customer.address_line1","typeLabel":"string"},"address_line2":{"type":"string","description":"AddressLine2 is the second line of the customer's address","uniqueKey":"customer.address_line2","typeLabel":"string"},"address_postal_code":{"type":"string","description":"AddressPostalCode is the postal code of the customer's address","uniqueKey":"customer.address_postal_code","typeLabel":"string"},"address_state":{"type":"string","description":"AddressState is the state of the customer's address","uniqueKey":"customer.address_state","typeLabel":"string"},"billing_currency":{"type":"string","description":"BillingCurrency is the fiat currency invoices are issued in; nil means charge currency is used as-is.","uniqueKey":"customer.billing_currency","typeLabel":"string"},"contact":{"type":"string","description":"Contact is an optional contact number for the customer (e.g. phone)","uniqueKey":"customer.contact","typeLabel":"string"},"contact_persons":{"type":"array","items":{"required":["first_name"],"type":"object","properties":{"first_name":{"maxLength":100,"type":"string","isRequired":true,"uniqueKey":"customer.contact_persons.items.[INDEX].first_name","typeLabel":"string"},"department":{"maxLength":100,"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].department","typeLabel":"string"},"designation":{"maxLength":100,"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].designation","typeLabel":"string"},"email":{"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].email","typeLabel":"string"},"id":{"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].id","typeLabel":"string"},"is_primary":{"type":"boolean","uniqueKey":"customer.contact_persons.items.[INDEX].is_primary","typeLabel":"boolean"},"last_name":{"maxLength":100,"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].last_name","typeLabel":"string"},"mobile":{"maxLength":20,"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].mobile","typeLabel":"string"},"salutation":{"maxLength":25,"type":"string","uniqueKey":"customer.contact_persons.items.[INDEX].salutation","typeLabel":"string"}},"uniqueKey":"customer.contact_persons.items.[INDEX]","typeLabel":"object"},"uniqueKey":"customer.contact_persons","typeLabel":"object[]"},"created_at":{"type":"string","format":"date-time","uniqueKey":"customer.created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"customer.created_by","typeLabel":"string"},"email":{"type":"string","description":"Email is the email of the customer","uniqueKey":"customer.email","typeLabel":"string"},"environment_id":{"type":"string","description":"EnvironmentID is the environment identifier for the customer","uniqueKey":"customer.environment_id","typeLabel":"string"},"external_id":{"type":"string","description":"ExternalID is the external identifier for the customer","uniqueKey":"customer.external_id","typeLabel":"string"},"id":{"type":"string","description":"ID is the unique identifier for the customer","uniqueKey":"customer.id","typeLabel":"string"},"integrations":{"type":"array","items":{"type":"object","properties":{"created_at":{"type":"string","format":"date-time","uniqueKey":"customer.integrations.items.[INDEX].created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].created_by","typeLabel":"string"},"entity_id":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].entity_id","typeLabel":"string"},"entity_type":{"type":"string","enum":["customer","plan","invoice","subscription","payment","credit_note","addon","item","item_price","price","invoice_line_item","subscription_line_item"],"x-enum-varnames":["IntegrationEntityTypeCustomer","IntegrationEntityTypePlan","IntegrationEntityTypeInvoice","IntegrationEntityTypeSubscription","IntegrationEntityTypePayment","IntegrationEntityTypeCreditNote","IntegrationEntityTypeAddon","IntegrationEntityTypeItem","IntegrationEntityTypeItemPrice","IntegrationEntityTypePrice","IntegrationEntityTypeInvoiceLineItem","IntegrationEntityTypeSubscriptionLineItem"],"x-speakeasy-name-override":"IntegrationEntityType","uniqueKey":"customer.integrations.items.[INDEX].entity_type","typeLabel":"enum\u003cstring>"},"environment_id":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].environment_id","typeLabel":"string"},"id":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].id","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":true,"uniqueKey":"customer.integrations.items.[INDEX].metadata","typeLabel":"object"},"provider_entity_id":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].provider_entity_id","typeLabel":"string"},"provider_type":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].provider_type","typeLabel":"string"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"customer.integrations.items.[INDEX].status","typeLabel":"enum\u003cstring>"},"tenant_id":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].tenant_id","typeLabel":"string"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"customer.integrations.items.[INDEX].updated_at","typeLabel":"string\u003cdate-time>"},"updated_by":{"type":"string","uniqueKey":"customer.integrations.items.[INDEX].updated_by","typeLabel":"string"}},"uniqueKey":"customer.integrations.items.[INDEX]","typeLabel":"object"},"uniqueKey":"customer.integrations","typeLabel":"object[]"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"customer.metadata.additionalProperties","typeLabel":"string"},"description":"Metadata","uniqueKey":"customer.metadata","typeLabel":"object"},"name":{"type":"string","description":"Name is the name of the customer","uniqueKey":"customer.name","typeLabel":"string"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"customer.status","typeLabel":"enum\u003cstring>"},"tax_treatment":{"type":"string","enum":["taxable","exempt"],"x-enum-varnames":["TaxTreatmentTaxable","TaxTreatmentExempt"],"x-speakeasy-name-override":"TaxTreatment","uniqueKey":"customer.tax_treatment","typeLabel":"enum\u003cstring>"},"tenant_id":{"type":"string","uniqueKey":"customer.tenant_id","typeLabel":"string"},"timezone":{"type":"string","description":"Timezone is the customer's IANA timezone name (e.g. \"Asia/Kolkata\").\nDefaults to \"UTC\". Inherited by subscriptions at creation time.","uniqueKey":"customer.timezone","typeLabel":"string"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"customer.updated_at","typeLabel":"string\u003cdate-time>"},"updated_by":{"type":"string","uniqueKey":"customer.updated_by","typeLabel":"string"}},"description":"Customer response object containing all customer information","uniqueKey":"customer","typeLabel":"object"},"customer_id":{"type":"string","description":"customer_id is the ID of the customer who will receive this invoice","uniqueKey":"customer_id","typeLabel":"string"},"description":{"type":"string","description":"description is an optional description or notes about this invoice","uniqueKey":"description","typeLabel":"string"},"due_date":{"type":"string","description":"due_date is the date when payment for this invoice is due","format":"date-time","uniqueKey":"due_date","typeLabel":"string\u003cdate-time>"},"environment_id":{"type":"string","description":"environment_id is the ID of the environment this invoice belongs to (for multi-environment setups)","uniqueKey":"environment_id","typeLabel":"string"},"finalized_at":{"type":"string","description":"finalized_at is the timestamp when this invoice was finalized and made ready for payment","format":"date-time","uniqueKey":"finalized_at","typeLabel":"string\u003cdate-time>"},"fx_conversion":{"type":"object","properties":{"billing_currency":{"type":"string","description":"BillingCurrency is the currency the invoice was issued in.","uniqueKey":"fx_conversion.billing_currency","typeLabel":"string"},"charge_currency":{"type":"string","description":"ChargeCurrency is the invoice's original (draft) currency.","uniqueKey":"fx_conversion.charge_currency","typeLabel":"string"},"converted_at":{"type":"string","description":"ConvertedAt is when the conversion ran.","format":"date-time","uniqueKey":"fx_conversion.converted_at","typeLabel":"string\u003cdate-time>"},"rate":{"type":"string","description":"Rate is the frozen rate: billing per 1 charge unit.","uniqueKey":"fx_conversion.rate","typeLabel":"string"},"rate_id":{"type":"string","description":"RateID is the fx_rates row used, for reference only; never read again.","uniqueKey":"fx_conversion.rate_id","typeLabel":"string"},"scope":{"type":"string","enum":["tenant","customer","subscription"],"x-enum-varnames":["FXRateScopeTenant","FXRateScopeCustomer","FXRateScopeSubscription"],"x-speakeasy-name-override":"FXRateScope","uniqueKey":"fx_conversion.scope","typeLabel":"enum\u003cstring>"},"source":{"type":"object","properties":{"net":{"type":"string","uniqueKey":"fx_conversion.source.net","typeLabel":"string"},"subtotal":{"type":"string","uniqueKey":"fx_conversion.source.subtotal","typeLabel":"string"},"total_discount":{"type":"string","uniqueKey":"fx_conversion.source.total_discount","typeLabel":"string"},"total_prepaid_credits_applied":{"type":"string","uniqueKey":"fx_conversion.source.total_prepaid_credits_applied","typeLabel":"string"}},"x-speakeasy-name-override":"FxConversionSource","uniqueKey":"fx_conversion.source","typeLabel":"object"}},"x-speakeasy-name-override":"FxConversion","uniqueKey":"fx_conversion","typeLabel":"object"},"hosted_invoice_url":{"type":"string","description":"hosted_invoice_url is the page where the customer can view, download and pay this invoice","uniqueKey":"hosted_invoice_url","typeLabel":"string"},"id":{"type":"string","description":"id is the unique identifier for this invoice","uniqueKey":"id","typeLabel":"string"},"idempotency_key":{"type":"string","description":"idempotency_key is a unique key used to prevent duplicate invoice creation when retrying API calls","uniqueKey":"idempotency_key","typeLabel":"string"},"invoice_number":{"type":"string","description":"invoice_number is the human-readable invoice number displayed to customers (e.g., INV-2024-001)","uniqueKey":"invoice_number","typeLabel":"string"},"invoice_pdf_url":{"type":"string","description":"invoice_pdf_url is the URL where customers can download the PDF version of this invoice","uniqueKey":"invoice_pdf_url","typeLabel":"string"},"invoice_status":{"type":"string","enum":["DRAFT","FINALIZED","VOIDED","SKIPPED"],"x-enum-varnames":["InvoiceStatusDraft","InvoiceStatusFinalized","InvoiceStatusVoided","InvoiceStatusSkipped"],"x-speakeasy-name-override":"InvoiceStatus","uniqueKey":"invoice_status","typeLabel":"enum\u003cstring>"},"invoice_type":{"type":"string","enum":["SUBSCRIPTION","ONE_OFF","CREDIT"],"x-enum-varnames":["InvoiceTypeSubscription","InvoiceTypeOneOff","InvoiceTypeCredit"],"x-speakeasy-name-override":"InvoiceType","uniqueKey":"invoice_type","typeLabel":"enum\u003cstring>"},"is_manually_edited":{"type":"boolean","description":"is_manually_edited is true once a user has manually added, edited, or removed a line item on this draft invoice.\nOnce set, automated recomputation of this invoice's line items must no-op rather than overwrite the manual edit.","uniqueKey":"is_manually_edited","typeLabel":"boolean"},"issue_date":{"type":"string","description":"issue_date is the user-facing date of the invoice. Defaults to created_at if not set.","format":"date-time","uniqueKey":"issue_date","typeLabel":"string\u003cdate-time>"},"last_computed_at":{"type":"string","description":"last_computed_at is the timestamp when this invoice was last computed by ComputeInvoice","format":"date-time","uniqueKey":"last_computed_at","typeLabel":"string\u003cdate-time>"},"line_items":{"type":"array","description":"line_items contains the individual items that make up this invoice (overrides embedded field)","items":{"type":"object","properties":{"adjusted_entitlement_quantity":{"type":"string","description":"adjusted_entitlement_quantity is the entitlement-covered portion deducted from raw usage.\nNil when no entitlement was applied. Raw usage = Quantity + AdjustedEntitlementQuantity.","uniqueKey":"line_items.items.[INDEX].adjusted_entitlement_quantity","typeLabel":"string"},"amount":{"type":"string","uniqueKey":"line_items.items.[INDEX].amount","typeLabel":"string"},"commitment_info":{"type":"object","properties":{"amount":{"type":"string","uniqueKey":"line_items.items.[INDEX].commitment_info.amount","typeLabel":"string"},"computed_commitment_utilized_amount":{"type":"string","uniqueKey":"line_items.items.[INDEX].commitment_info.computed_commitment_utilized_amount","typeLabel":"string"},"computed_overage_amount":{"type":"string","uniqueKey":"line_items.items.[INDEX].commitment_info.computed_overage_amount","typeLabel":"string"},"computed_true_up_amount":{"type":"string","description":"total_cost = computed_commitment_utilized_amount + computed_overage_amount + computed_true_up_amount","uniqueKey":"line_items.items.[INDEX].commitment_info.computed_true_up_amount","typeLabel":"string"},"duration":{"type":"string","enum":["MONTHLY","ANNUAL","WEEKLY","DAILY","QUARTERLY","HALF_YEARLY","ONETIME"],"x-enum-varnames":["BILLING_PERIOD_MONTHLY","BILLING_PERIOD_ANNUAL","BILLING_PERIOD_WEEKLY","BILLING_PERIOD_DAILY","BILLING_PERIOD_QUARTER","BILLING_PERIOD_HALF_YEAR","BILLING_PERIOD_ONETIME"],"x-speakeasy-name-override":"BillingPeriod","uniqueKey":"line_items.items.[INDEX].commitment_info.duration","typeLabel":"enum\u003cstring>"},"is_windowed":{"type":"boolean","uniqueKey":"line_items.items.[INDEX].commitment_info.is_windowed","typeLabel":"boolean"},"overage_factor":{"type":"string","uniqueKey":"line_items.items.[INDEX].commitment_info.overage_factor","typeLabel":"string"},"quantity":{"type":"string","description":"Only used for quantity-based commitments","uniqueKey":"line_items.items.[INDEX].commitment_info.quantity","typeLabel":"string"},"true_up_enabled":{"type":"boolean","uniqueKey":"line_items.items.[INDEX].commitment_info.true_up_enabled","typeLabel":"boolean"},"type":{"type":"string","enum":["amount","quantity"],"x-enum-varnames":["COMMITMENT_TYPE_AMOUNT","COMMITMENT_TYPE_QUANTITY"],"x-speakeasy-name-override":"CommitmentType","uniqueKey":"line_items.items.[INDEX].commitment_info.type","typeLabel":"enum\u003cstring>"}},"x-speakeasy-name-override":"CommitmentInfo","uniqueKey":"line_items.items.[INDEX].commitment_info","typeLabel":"object"},"created_at":{"type":"string","format":"date-time","uniqueKey":"line_items.items.[INDEX].created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"line_items.items.[INDEX].created_by","typeLabel":"string"},"currency":{"type":"string","uniqueKey":"line_items.items.[INDEX].currency","typeLabel":"string"},"custom_currency":{"type":"object","properties":{"amount":{"type":"string","uniqueKey":"line_items.items.[INDEX].custom_currency.amount","typeLabel":"string"},"invoice_level_discount":{"type":"string","uniqueKey":"line_items.items.[INDEX].custom_currency.invoice_level_discount","typeLabel":"string"},"line_item_discount":{"type":"string","uniqueKey":"line_items.items.[INDEX].custom_currency.line_item_discount","typeLabel":"string"},"prepaid_credits_applied":{"type":"string","uniqueKey":"line_items.items.[INDEX].custom_currency.prepaid_credits_applied","typeLabel":"string"}},"x-speakeasy-name-override":"CustomCurrencyLineItem","uniqueKey":"line_items.items.[INDEX].custom_currency","typeLabel":"object"},"customer_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].customer_id","typeLabel":"string"},"display_name":{"type":"string","uniqueKey":"line_items.items.[INDEX].display_name","typeLabel":"string"},"entity_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].entity_id","typeLabel":"string"},"entity_type":{"type":"string","uniqueKey":"line_items.items.[INDEX].entity_type","typeLabel":"string"},"environment_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].environment_id","typeLabel":"string"},"fx_conversion":{"type":"object","properties":{"billing_currency":{"type":"string","description":"BillingCurrency is the currency the invoice was issued in.","uniqueKey":"line_items.items.[INDEX].fx_conversion.billing_currency","typeLabel":"string"},"charge_currency":{"type":"string","description":"ChargeCurrency is the invoice's original (draft) currency.","uniqueKey":"line_items.items.[INDEX].fx_conversion.charge_currency","typeLabel":"string"},"converted_at":{"type":"string","description":"ConvertedAt is when the conversion ran.","format":"date-time","uniqueKey":"line_items.items.[INDEX].fx_conversion.converted_at","typeLabel":"string\u003cdate-time>"},"rate":{"type":"string","description":"Rate is the frozen rate: billing per 1 charge unit.","uniqueKey":"line_items.items.[INDEX].fx_conversion.rate","typeLabel":"string"},"rate_id":{"type":"string","description":"RateID is the fx_rates row used, for reference only; never read again.","uniqueKey":"line_items.items.[INDEX].fx_conversion.rate_id","typeLabel":"string"},"scope":{"type":"string","enum":["tenant","customer","subscription"],"x-enum-varnames":["FXRateScopeTenant","FXRateScopeCustomer","FXRateScopeSubscription"],"x-speakeasy-name-override":"FXRateScope","uniqueKey":"line_items.items.[INDEX].fx_conversion.scope","typeLabel":"enum\u003cstring>"},"source":{"type":"object","properties":{"net":{"type":"string","uniqueKey":"line_items.items.[INDEX].fx_conversion.source.net","typeLabel":"string"},"subtotal":{"type":"string","uniqueKey":"line_items.items.[INDEX].fx_conversion.source.subtotal","typeLabel":"string"},"total_discount":{"type":"string","uniqueKey":"line_items.items.[INDEX].fx_conversion.source.total_discount","typeLabel":"string"},"total_prepaid_credits_applied":{"type":"string","uniqueKey":"line_items.items.[INDEX].fx_conversion.source.total_prepaid_credits_applied","typeLabel":"string"}},"x-speakeasy-name-override":"FxConversionSource","uniqueKey":"line_items.items.[INDEX].fx_conversion.source","typeLabel":"object"}},"x-speakeasy-name-override":"FxConversion","uniqueKey":"line_items.items.[INDEX].fx_conversion","typeLabel":"object"},"id":{"type":"string","uniqueKey":"line_items.items.[INDEX].id","typeLabel":"string"},"invoice_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].invoice_id","typeLabel":"string"},"invoice_level_discount":{"type":"string","description":"invoice_level_discount is the discount amount in invoice currency applied to all line items on the invoice.","uniqueKey":"line_items.items.[INDEX].invoice_level_discount","typeLabel":"string"},"line_item_discount":{"type":"string","description":"line_item_discount is the discount amount in invoice currency applied directly to this line item.","uniqueKey":"line_items.items.[INDEX].line_item_discount","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"line_items.items.[INDEX].metadata.additionalProperties","typeLabel":"string"},"x-speakeasy-name-override":"Metadata","uniqueKey":"line_items.items.[INDEX].metadata","typeLabel":"object"},"meter_display_name":{"type":"string","uniqueKey":"line_items.items.[INDEX].meter_display_name","typeLabel":"string"},"meter_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].meter_id","typeLabel":"string"},"parent_line_item_id":{"type":"string","description":"parent_line_item_id links this line item to the line item it replaced, if it was created by editing\nan existing line item. Forms a linked-list chain across edits; nil for line items that were never edited.","uniqueKey":"line_items.items.[INDEX].parent_line_item_id","typeLabel":"string"},"period_end":{"type":"string","format":"date-time","uniqueKey":"line_items.items.[INDEX].period_end","typeLabel":"string\u003cdate-time>"},"period_start":{"type":"string","format":"date-time","uniqueKey":"line_items.items.[INDEX].period_start","typeLabel":"string\u003cdate-time>"},"plan_display_name":{"type":"string","uniqueKey":"line_items.items.[INDEX].plan_display_name","typeLabel":"string"},"prepaid_credits_applied":{"type":"string","description":"prepaid_credits_applied is the amount in invoice currency reduced from this line item due to prepaid credits application.","uniqueKey":"line_items.items.[INDEX].prepaid_credits_applied","typeLabel":"string"},"price_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].price_id","typeLabel":"string"},"price_type":{"type":"string","uniqueKey":"line_items.items.[INDEX].price_type","typeLabel":"string"},"price_unit":{"type":"string","uniqueKey":"line_items.items.[INDEX].price_unit","typeLabel":"string"},"price_unit_amount":{"type":"string","uniqueKey":"line_items.items.[INDEX].price_unit_amount","typeLabel":"string"},"price_unit_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].price_unit_id","typeLabel":"string"},"quantity":{"type":"string","uniqueKey":"line_items.items.[INDEX].quantity","typeLabel":"string"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"line_items.items.[INDEX].status","typeLabel":"enum\u003cstring>"},"subscription_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].subscription_id","typeLabel":"string"},"subscription_line_item_id":{"type":"string","description":"sub_line_item_id links this invoice line item to the subscription_line_item that generated it.","uniqueKey":"line_items.items.[INDEX].subscription_line_item_id","typeLabel":"string"},"tenant_id":{"type":"string","uniqueKey":"line_items.items.[INDEX].tenant_id","typeLabel":"string"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"line_items.items.[INDEX].updated_at","typeLabel":"string\u003cdate-time>"},"updated_by":{"type":"string","uniqueKey":"line_items.items.[INDEX].updated_by","typeLabel":"string"},"usage_analytics":{"type":"array","description":"usage_analytics contains usage analytics for this line item (legacy - grouped by source)","items":{"type":"object","properties":{"cost":{"type":"string","description":"cost is the cost attributed to this source for the line item","uniqueKey":"line_items.items.[INDEX].usage_analytics.items.[INDEX].cost","typeLabel":"string"},"event_count":{"type":"integer","description":"event_count is the number of events from this source (optional)","uniqueKey":"line_items.items.[INDEX].usage_analytics.items.[INDEX].event_count","typeLabel":"integer"},"percentage":{"type":"string","description":"percentage is the percentage of total line item cost from this source (optional)","uniqueKey":"line_items.items.[INDEX].usage_analytics.items.[INDEX].percentage","typeLabel":"string"},"source":{"type":"string","description":"source is the name of the event source","uniqueKey":"line_items.items.[INDEX].usage_analytics.items.[INDEX].source","typeLabel":"string"},"usage":{"type":"string","description":"usage is the total usage amount from this source (optional, for additional context)","uniqueKey":"line_items.items.[INDEX].usage_analytics.items.[INDEX].usage","typeLabel":"string"}},"uniqueKey":"line_items.items.[INDEX].usage_analytics.items.[INDEX]","typeLabel":"object"},"uniqueKey":"line_items.items.[INDEX].usage_analytics","typeLabel":"object[]"},"usage_breakdown":{"type":"array","description":"usage_breakdown contains flexible usage breakdown for this line item (supports any grouping)","items":{"type":"object","properties":{"cost":{"type":"string","description":"cost is the cost attributed to this group for the line item","uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX].cost","typeLabel":"string"},"event_count":{"type":"integer","description":"event_count is the number of events from this group (optional)","uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX].event_count","typeLabel":"integer"},"grouped_by":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX].grouped_by.additionalProperties","typeLabel":"string"},"description":"grouped_by contains the grouping field values (e.g., {\"source\": \"api\", \"org_id\": \"org123\"})","uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX].grouped_by","typeLabel":"object"},"percentage":{"type":"string","description":"percentage is the percentage of total line item cost from this group (optional)","uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX].percentage","typeLabel":"string"},"usage":{"type":"string","description":"usage is the total usage amount from this group (optional, for additional context)","uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX].usage","typeLabel":"string"}},"uniqueKey":"line_items.items.[INDEX].usage_breakdown.items.[INDEX]","typeLabel":"object"},"uniqueKey":"line_items.items.[INDEX].usage_breakdown","typeLabel":"object[]"}},"uniqueKey":"line_items.items.[INDEX]","typeLabel":"object"},"uniqueKey":"line_items","typeLabel":"object[]"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"metadata.additionalProperties","typeLabel":"string"},"x-speakeasy-name-override":"Metadata","uniqueKey":"metadata","typeLabel":"object"},"overpaid_amount":{"type":"string","description":"overpaid_amount is the amount overpaid if payment_status is OVERPAID (amount_paid - total)","uniqueKey":"overpaid_amount","typeLabel":"string"},"paid_at":{"type":"string","description":"paid_at is the timestamp when this invoice was fully paid","format":"date-time","uniqueKey":"paid_at","typeLabel":"string\u003cdate-time>"},"payment_status":{"type":"string","enum":["INITIATED","PENDING","PROCESSING","SUCCEEDED","OVERPAID","FAILED","REFUNDED","PARTIALLY_REFUNDED","VOIDED"],"x-enum-varnames":["PaymentStatusInitiated","PaymentStatusPending","PaymentStatusProcessing","PaymentStatusSucceeded","PaymentStatusOverpaid","PaymentStatusFailed","PaymentStatusRefunded","PaymentStatusPartiallyRefunded","PaymentStatusVoided"],"x-speakeasy-name-override":"PaymentStatus","uniqueKey":"payment_status","typeLabel":"enum\u003cstring>"},"period_end":{"type":"string","description":"period_end is the end date of the billing period covered by this invoice","format":"date-time","uniqueKey":"period_end","typeLabel":"string\u003cdate-time>"},"period_start":{"type":"string","description":"period_start is the start date of the billing period covered by this invoice","format":"date-time","uniqueKey":"period_start","typeLabel":"string\u003cdate-time>"},"recalculated_invoice_id":{"type":"string","description":"recalculated_invoice_id is the ID of the replacement invoice created when this invoice was voided and recalculated.\nWhen set, it forms a parent→child link from this (voided) invoice to the new replacement invoice.","uniqueKey":"recalculated_invoice_id","typeLabel":"string"},"refunded_amount":{"type":"string","description":"refunded_amount is the total sum of credit notes of type \"refund\".\nThese are actual refunds issued to the customer.","uniqueKey":"refunded_amount","typeLabel":"string"},"source_type":{"type":"string","enum":["checkout"],"x-enum-varnames":["InvoiceSourceTypeCheckout"],"x-speakeasy-name-override":"InvoiceSourceType","uniqueKey":"source_type","typeLabel":"enum\u003cstring>"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"status","typeLabel":"enum\u003cstring>"},"subscription":{"type":"object","properties":{"active_pause_id":{"type":"string","description":"ActivePauseID references the current active pause configuration\nThis will be null if no pause is active or scheduled","uniqueKey":"subscription.active_pause_id","typeLabel":"string"},"auto_invoice_threshold":{"type":"string","description":"AutoInvoiceThreshold is the usage amount (in subscription currency) that triggers\nan intermediate invoice. Overrides the plan-level threshold when set.\nNil means: inherit from the plan's threshold (which may also be nil = disabled).","uniqueKey":"subscription.auto_invoice_threshold","typeLabel":"string"},"billing_anchor":{"type":"string","description":"BillingAnchor is the reference point that aligns future billing cycle dates.\nIt sets the day of week for week intervals, the day of month for month and year intervals,\nand the month of year for year intervals. The timestamp is in UTC format.","format":"date-time","uniqueKey":"subscription.billing_anchor","typeLabel":"string\u003cdate-time>"},"billing_cadence":{"type":"string","enum":["RECURRING"],"x-enum-varnames":["BILLING_CADENCE_RECURRING"],"x-speakeasy-name-override":"BillingCadence","uniqueKey":"subscription.billing_cadence","typeLabel":"enum\u003cstring>"},"billing_cycle":{"type":"string","enum":["anniversary","calendar"],"x-enum-varnames":["BillingCycleAnniversary","BillingCycleCalendar"],"x-speakeasy-name-override":"BillingCycle","uniqueKey":"subscription.billing_cycle","typeLabel":"enum\u003cstring>"},"billing_period":{"type":"string","enum":["MONTHLY","ANNUAL","WEEKLY","DAILY","QUARTERLY","HALF_YEARLY","ONETIME"],"x-enum-varnames":["BILLING_PERIOD_MONTHLY","BILLING_PERIOD_ANNUAL","BILLING_PERIOD_WEEKLY","BILLING_PERIOD_DAILY","BILLING_PERIOD_QUARTER","BILLING_PERIOD_HALF_YEAR","BILLING_PERIOD_ONETIME"],"x-speakeasy-name-override":"BillingPeriod","uniqueKey":"subscription.billing_period","typeLabel":"enum\u003cstring>"},"billing_period_count":{"type":"integer","description":"BillingPeriodCount is the total number units of the billing period.","uniqueKey":"subscription.billing_period_count","typeLabel":"integer"},"cancel_at":{"type":"string","description":"CancelAt is the date the subscription will be canceled","format":"date-time","uniqueKey":"subscription.cancel_at","typeLabel":"string\u003cdate-time>"},"cancel_at_period_end":{"type":"boolean","description":"CancelAtPeriodEnd is whether the subscription was canceled at the end of the current period","uniqueKey":"subscription.cancel_at_period_end","typeLabel":"boolean"},"cancelled_at":{"type":"string","description":"CanceledAt is the date the subscription was canceled","format":"date-time","uniqueKey":"subscription.cancelled_at","typeLabel":"string\u003cdate-time>"},"checkout_session":{"type":"object","properties":{"action":{"type":"string","enum":["create_subscription","modify_subscription","wallet_topup","add_addon","pay_invoice"],"x-enum-varnames":["CheckoutActionCreateSubscription","CheckoutActionModifySubscription","CheckoutActionWalletTopup","CheckoutActionAddAddon","CheckoutActionPayInvoice"],"x-speakeasy-name-override":"CheckoutAction","uniqueKey":"subscription.checkout_session.action","typeLabel":"enum\u003cstring>"},"cancel_url":{"type":"string","uniqueKey":"subscription.checkout_session.cancel_url","typeLabel":"string"},"cancelled_at":{"type":"string","format":"date-time","uniqueKey":"subscription.checkout_session.cancelled_at","typeLabel":"string\u003cdate-time>"},"checkout_invoice_id":{"type":"string","uniqueKey":"subscription.checkout_session.checkout_invoice_id","typeLabel":"string"},"checkout_payment_id":{"type":"string","uniqueKey":"subscription.checkout_session.checkout_payment_id","typeLabel":"string"},"checkout_status":{"type":"string","enum":["initiated","pending","completed","failed","expired"],"x-enum-varnames":["CheckoutStatusInitiated","CheckoutStatusPending","CheckoutStatusCompleted","CheckoutStatusFailed","CheckoutStatusExpired"],"x-speakeasy-name-override":"CheckoutStatus","uniqueKey":"subscription.checkout_session.checkout_status","typeLabel":"enum\u003cstring>"},"completed_at":{"type":"string","format":"date-time","uniqueKey":"subscription.checkout_session.completed_at","typeLabel":"string\u003cdate-time>"},"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.checkout_session.created_at","typeLabel":"string\u003cdate-time>"},"customer_id":{"type":"string","uniqueKey":"subscription.checkout_session.customer_id","typeLabel":"string"},"entity_creation_result":{"type":"object","properties":{"entity_id":{"type":"string","uniqueKey":"subscription.checkout_session.entity_creation_result.entity_id","typeLabel":"string"},"status":{"type":"string","enum":["created","superseded","failed_already_exists"],"x-enum-varnames":["EntityCreationStatusCreated","EntityCreationStatusSuperseded","EntityCreationStatusFailedAlreadyExists"],"x-speakeasy-name-override":"EntityCreationStatus","uniqueKey":"subscription.checkout_session.entity_creation_result.status","typeLabel":"enum\u003cstring>"}},"uniqueKey":"subscription.checkout_session.entity_creation_result","typeLabel":"object"},"expires_at":{"type":"string","format":"date-time","uniqueKey":"subscription.checkout_session.expires_at","typeLabel":"string\u003cdate-time>"},"failure_reason":{"type":"string","uniqueKey":"subscription.checkout_session.failure_reason","typeLabel":"string"},"failure_url":{"type":"string","uniqueKey":"subscription.checkout_session.failure_url","typeLabel":"string"},"id":{"type":"string","uniqueKey":"subscription.checkout_session.id","typeLabel":"string"},"idempotency_key":{"type":"string","uniqueKey":"subscription.checkout_session.idempotency_key","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"subscription.checkout_session.metadata.additionalProperties","typeLabel":"string"},"x-speakeasy-name-override":"Metadata","uniqueKey":"subscription.checkout_session.metadata","typeLabel":"object"},"next_poll_after_ms":{"type":"integer","description":"NextPollAfterMs is how long a client should wait before reading again.\nZero means stop — either the session is terminal, or this response did not\ncome from a polling read.","uniqueKey":"subscription.checkout_session.next_poll_after_ms","typeLabel":"integer"},"payment":{"type":"object","properties":{"gateway":{"type":"string","uniqueKey":"subscription.checkout_session.payment.gateway","typeLabel":"string"},"id":{"type":"string","uniqueKey":"subscription.checkout_session.payment.id","typeLabel":"string"},"status":{"type":"string","enum":["INITIATED","PENDING","PROCESSING","SUCCEEDED","OVERPAID","FAILED","REFUNDED","PARTIALLY_REFUNDED","VOIDED"],"x-enum-varnames":["PaymentStatusInitiated","PaymentStatusPending","PaymentStatusProcessing","PaymentStatusSucceeded","PaymentStatusOverpaid","PaymentStatusFailed","PaymentStatusRefunded","PaymentStatusPartiallyRefunded","PaymentStatusVoided"],"x-speakeasy-name-override":"PaymentStatus","uniqueKey":"subscription.checkout_session.payment.status","typeLabel":"enum\u003cstring>"}},"uniqueKey":"subscription.checkout_session.payment","typeLabel":"object"},"payment_action":{"type":"object","properties":{"type":{"type":"string","enum":["checkout_url","payment_link"],"x-enum-varnames":["PaymentActionTypeCheckoutURL","PaymentActionTypePaymentLink"],"x-speakeasy-name-override":"PaymentActionType","uniqueKey":"subscription.checkout_session.payment_action.type","typeLabel":"enum\u003cstring>"},"url":{"type":"string","uniqueKey":"subscription.checkout_session.payment_action.url","typeLabel":"string"}},"x-speakeasy-name-override":"PaymentAction","uniqueKey":"subscription.checkout_session.payment_action","typeLabel":"object"},"payment_provider":{"type":"string","enum":["razorpay","chargebee","stripe"],"x-enum-varnames":["CheckoutPaymentProviderRazorpay","CheckoutPaymentProviderChargebee","CheckoutPaymentProviderStripe"],"x-speakeasy-name-override":"CheckoutPaymentProvider","uniqueKey":"subscription.checkout_session.payment_provider","typeLabel":"enum\u003cstring>"},"stale":{"type":"boolean","description":"Stale reports that this response is stored state that was not checked against\nthe payment provider on this request — the read was debounced, or the gateway\ndid not answer. A UI should say \"still checking\" rather than presenting a\nstale answer as fact.","uniqueKey":"subscription.checkout_session.stale","typeLabel":"boolean"},"success_url":{"type":"string","uniqueKey":"subscription.checkout_session.success_url","typeLabel":"string"},"terminal":{"type":"boolean","description":"Terminal reports whether the session has finished. Clients poll until this is\ntrue rather than hardcoding the status set, which would go stale if a status\nis ever added.","uniqueKey":"subscription.checkout_session.terminal","typeLabel":"boolean"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"subscription.checkout_session.updated_at","typeLabel":"string\u003cdate-time>"}},"uniqueKey":"subscription.checkout_session","typeLabel":"object"},"collection_method":{"type":"string","description":"CollectionMethod determines how invoices are collected","uniqueKey":"subscription.collection_method","typeLabel":"string"},"commitment_amount":{"type":"string","description":"CommitmentAmount is the minimum amount a customer commits to paying for a billing period","uniqueKey":"subscription.commitment_amount","typeLabel":"string"},"commitment_duration":{"type":"string","enum":["MONTHLY","ANNUAL","WEEKLY","DAILY","QUARTERLY","HALF_YEARLY","ONETIME"],"x-enum-varnames":["BILLING_PERIOD_MONTHLY","BILLING_PERIOD_ANNUAL","BILLING_PERIOD_WEEKLY","BILLING_PERIOD_DAILY","BILLING_PERIOD_QUARTER","BILLING_PERIOD_HALF_YEAR","BILLING_PERIOD_ONETIME"],"x-speakeasy-name-override":"BillingPeriod","uniqueKey":"subscription.commitment_duration","typeLabel":"enum\u003cstring>"},"coupon_associations":{"type":"array","description":"CouponAssociations are the coupon associations for this subscription","items":{"type":"object","properties":{"coupon":{"type":"object","properties":{"amount_off":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.amount_off","typeLabel":"string"},"cadence":{"type":"string","enum":["once","repeated","forever"],"x-enum-varnames":["CouponCadenceOnce","CouponCadenceRepeated","CouponCadenceForever"],"x-speakeasy-name-override":"CouponCadence","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.cadence","typeLabel":"enum\u003cstring>"},"coupon_code":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.coupon_code","typeLabel":"string"},"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.created_by","typeLabel":"string"},"currency":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.currency","typeLabel":"string"},"duration_in_periods":{"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.duration_in_periods","typeLabel":"integer"},"environment_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.environment_id","typeLabel":"string"},"id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.id","typeLabel":"string"},"max_redemptions":{"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.max_redemptions","typeLabel":"integer"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.metadata.additionalProperties","typeLabel":"string"},"uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.metadata","typeLabel":"object"},"name":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.name","typeLabel":"string"},"percentage_off":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.percentage_off","typeLabel":"string"},"redeem_after":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.redeem_after","typeLabel":"string"},"redeem_before":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.redeem_before","typeLabel":"string"},"rules":{"type":"object","additionalProperties":true,"uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.rules","typeLabel":"object"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.status","typeLabel":"enum\u003cstring>"},"tenant_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.tenant_id","typeLabel":"string"},"total_redemptions":{"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.total_redemptions","typeLabel":"integer"},"type":{"type":"string","enum":["fixed","percentage"],"x-enum-varnames":["CouponTypeFixed","CouponTypePercentage"],"x-speakeasy-name-override":"CouponType","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.type","typeLabel":"enum\u003cstring>"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.updated_at","typeLabel":"string\u003cdate-time>"},"updated_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon.updated_by","typeLabel":"string"}},"uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon","typeLabel":"object"},"coupon_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].coupon_id","typeLabel":"string"},"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].created_by","typeLabel":"string"},"end_date":{"type":"string","description":"Optional","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].end_date","typeLabel":"string\u003cdate-time>"},"environment_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].environment_id","typeLabel":"string"},"id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].id","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].metadata.additionalProperties","typeLabel":"string"},"uniqueKey":"subscription.coupon_associations.items.[INDEX].metadata","typeLabel":"object"},"start_date":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].start_date","typeLabel":"string\u003cdate-time>"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"subscription.coupon_associations.items.[INDEX].status","typeLabel":"enum\u003cstring>"},"subscription_id":{"type":"string","description":"Mandatory","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_id","typeLabel":"string"},"subscription_line_item":{"type":"object","properties":{"addon_association_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.addon_association_id","typeLabel":"string"},"billing_period":{"type":"string","enum":["MONTHLY","ANNUAL","WEEKLY","DAILY","QUARTERLY","HALF_YEARLY","ONETIME"],"x-enum-varnames":["BILLING_PERIOD_MONTHLY","BILLING_PERIOD_ANNUAL","BILLING_PERIOD_WEEKLY","BILLING_PERIOD_DAILY","BILLING_PERIOD_QUARTER","BILLING_PERIOD_HALF_YEAR","BILLING_PERIOD_ONETIME"],"x-speakeasy-name-override":"BillingPeriod","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.billing_period","typeLabel":"enum\u003cstring>"},"billing_period_count":{"type":"integer","description":"from price at create; default 1","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.billing_period_count","typeLabel":"integer"},"commitment_amount":{"type":"string","description":"Commitment fields","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_amount","typeLabel":"string"},"commitment_duration":{"type":"string","enum":["MONTHLY","ANNUAL","WEEKLY","DAILY","QUARTERLY","HALF_YEARLY","ONETIME"],"x-enum-varnames":["BILLING_PERIOD_MONTHLY","BILLING_PERIOD_ANNUAL","BILLING_PERIOD_WEEKLY","BILLING_PERIOD_DAILY","BILLING_PERIOD_QUARTER","BILLING_PERIOD_HALF_YEAR","BILLING_PERIOD_ONETIME"],"x-speakeasy-name-override":"BillingPeriod","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_duration","typeLabel":"enum\u003cstring>"},"commitment_overage_factor":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_overage_factor","typeLabel":"string"},"commitment_quantity":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_quantity","typeLabel":"string"},"commitment_time_buckets":{"type":"array","items":{"type":"object","properties":{"commitment_type":{"type":"string","enum":["amount","quantity"],"x-enum-varnames":["COMMITMENT_TYPE_AMOUNT","COMMITMENT_TYPE_QUANTITY"],"x-speakeasy-name-override":"CommitmentType","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].commitment_type","typeLabel":"enum\u003cstring>"},"commitment_value":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].commitment_value","typeLabel":"string"},"end":{"type":"object","properties":{"hour":{"maximum":24,"minimum":0,"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].end.hour","typeLabel":"integer"},"minute":{"maximum":59,"minimum":0,"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].end.minute","typeLabel":"integer"}},"x-speakeasy-name-override":"Bucket","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].end","typeLabel":"object"},"id":{"type":"string","description":"ID is server-assigned. Stable for the lifetime of the line item;\ninvoice breakdown and analytics responses reference this ID.","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].id","typeLabel":"string"},"overage_factor":{"type":"number","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].overage_factor","typeLabel":"number"},"price_id":{"type":"string","description":"PriceID is the SUBSCRIPTION-scoped price created at bucket-creation time.\nImmutable post-create; changing pricing requires a successor line item.","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].price_id","typeLabel":"string"},"start":{"type":"object","properties":{"hour":{"maximum":24,"minimum":0,"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].start.hour","typeLabel":"integer"},"minute":{"maximum":59,"minimum":0,"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].start.minute","typeLabel":"integer"}},"x-speakeasy-name-override":"Bucket","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].start","typeLabel":"object"},"true_up_enabled":{"type":"boolean","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX].true_up_enabled","typeLabel":"boolean"}},"x-speakeasy-name-override":"TimeOfDayBucket","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets.items.[INDEX]","typeLabel":"object"},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_time_buckets","typeLabel":"object[]"},"commitment_true_up_enabled":{"type":"boolean","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_true_up_enabled","typeLabel":"boolean"},"commitment_type":{"type":"string","enum":["amount","quantity"],"x-enum-varnames":["COMMITMENT_TYPE_AMOUNT","COMMITMENT_TYPE_QUANTITY"],"x-speakeasy-name-override":"CommitmentType","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_type","typeLabel":"enum\u003cstring>"},"commitment_windowed":{"type":"boolean","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.commitment_windowed","typeLabel":"boolean"},"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.created_by","typeLabel":"string"},"currency":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.currency","typeLabel":"string"},"customer_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.customer_id","typeLabel":"string"},"display_name":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.display_name","typeLabel":"string"},"end_date":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.end_date","typeLabel":"string\u003cdate-time>"},"entity_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.entity_id","typeLabel":"string"},"entity_type":{"type":"string","enum":["plan","addon","subscription"],"x-enum-varnames":["SubscriptionLineItemEntityTypePlan","SubscriptionLineItemEntityTypeAddon","SubscriptionLineItemEntityTypeSubscription"],"x-speakeasy-name-override":"SubscriptionLineItemEntityType","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.entity_type","typeLabel":"enum\u003cstring>"},"environment_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.environment_id","typeLabel":"string"},"id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.id","typeLabel":"string"},"invoice_cadence":{"type":"string","enum":["ARREAR","ADVANCE"],"x-enum-varnames":["InvoiceCadenceArrear","InvoiceCadenceAdvance"],"x-speakeasy-name-override":"InvoiceCadence","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.invoice_cadence","typeLabel":"enum\u003cstring>"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.metadata.additionalProperties","typeLabel":"string"},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.metadata","typeLabel":"object"},"meter":{"type":"object","properties":{"aggregation":{"type":"object","properties":{"bucket_size":{"type":"string","enum":["MINUTE","15MIN","30MIN","HOUR","3HOUR","6HOUR","12HOUR","DAY","WEEK","MONTH"],"x-enum-varnames":["WindowSizeMinute","WindowSize15Min","WindowSize30Min","WindowSizeHour","WindowSize3Hour","WindowSize6Hour","WindowSize12Hour","WindowSizeDay","WindowSizeWeek","WindowSizeMonth"],"x-speakeasy-name-override":"WindowSize","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation.bucket_size","typeLabel":"enum\u003cstring>"},"expression":{"type":"string","description":"Expression is an optional CEL expression to compute per-event quantity from event.properties.\nWhen set, it replaces Field-based extraction. Property names are used directly (e.g., token * duration * pixel).","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation.expression","typeLabel":"string"},"field":{"type":"string","description":"Field is the key in $event.properties on which the aggregation is to be applied\nFor ex if the aggregation type is sum for API usage, the field could be \"duration_ms\"\nIgnored when Expression is set.","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation.field","typeLabel":"string"},"group_by":{"type":"string","description":"GroupBy is the property name in event.properties to group by before aggregating.\nRequires MAX aggregation. Windowing comes from the price, so this no longer\nimplies a meter-level bucket_size.\nWhen set, aggregation is applied per unique value of this property within each bucket,\nthen the per-group results are summed to produce the bucket total.","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation.group_by","typeLabel":"string"},"multiplier":{"type":"string","description":"Multiplier is the multiplier for the aggregation\nFor ex if the aggregation type is sum_with_multiplier for API usage, the multiplier could be 1000\nto scale up by a factor of 1000. If not provided, it will be null.","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation.multiplier","typeLabel":"string"},"type":{"type":"string","enum":["COUNT","SUM","AVG","COUNT_UNIQUE","LATEST","SUM_WITH_MULTIPLIER","MAX","WEIGHTED_SUM"],"x-enum-comments":{"AggregationSumWithMultiplier":"Sum with a multiplier - [sum(value) * multiplier]"},"x-enum-varnames":["AggregationCount","AggregationSum","AggregationAvg","AggregationCountUnique","AggregationLatest","AggregationSumWithMultiplier","AggregationMax","AggregationWeightedSum"],"x-speakeasy-name-override":"AggregationType","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation.type","typeLabel":"enum\u003cstring>"}},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.aggregation","typeLabel":"object"},"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.created_by","typeLabel":"string"},"environment_id":{"type":"string","description":"EnvironmentID is the environment identifier for the meter","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.environment_id","typeLabel":"string"},"event_name":{"type":"string","description":"EventName is the unique identifier for the event that this meter is tracking\nIt is a mandatory field in the events table and hence being used as the primary matching field\nWe can have multiple meters tracking the same event but with different filters and aggregation","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.event_name","typeLabel":"string"},"filters":{"type":"array","description":"Filters define the criteria for the meter to be applied on the events before aggregation\nIt also defines the possible values on which later the charges will be applied","items":{"type":"object","properties":{"key":{"type":"string","description":"Key is the key for the filter from $event.properties\nCurrently we support only first level keys in the properties and not nested keys","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.filters.items.[INDEX].key","typeLabel":"string"},"values":{"type":"array","description":"Values are the possible values for the filter to be considered for the meter\nFor ex \"model_name\" could have values \"o1-mini\", \"gpt-4o\" etc","items":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.filters.items.[INDEX].values.items.[INDEX]","typeLabel":"string"},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.filters.items.[INDEX].values","typeLabel":"string[]"}},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.filters.items.[INDEX]","typeLabel":"object"},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.filters","typeLabel":"object[]"},"id":{"type":"string","description":"ID is the unique identifier for the meter","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.id","typeLabel":"string"},"name":{"type":"string","description":"Name is the display name of the meter","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.name","typeLabel":"string"},"reset_usage":{"type":"string","enum":["BILLING_PERIOD","NEVER"],"x-enum-varnames":["ResetUsageBillingPeriod","ResetUsageNever"],"x-speakeasy-name-override":"ResetUsage","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.reset_usage","typeLabel":"enum\u003cstring>"},"status":{"type":"string","enum":["published","deleted","archived"],"x-enum-varnames":["StatusPublished","StatusDeleted","StatusArchived"],"x-speakeasy-name-override":"Status","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.status","typeLabel":"enum\u003cstring>"},"tenant_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.tenant_id","typeLabel":"string"},"updated_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.updated_at","typeLabel":"string\u003cdate-time>"},"updated_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter.updated_by","typeLabel":"string"}},"uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter","typeLabel":"object"},"meter_display_name":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter_display_name","typeLabel":"string"},"meter_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.meter_id","typeLabel":"string"},"plan_display_name":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.plan_display_name","typeLabel":"string"},"price":{"type":"object","properties":{"addon":{"type":"object","properties":{"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.created_by","typeLabel":"string"},"credit_grants":{"type":"array","items":{"type":"object","properties":{"addon_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].addon_id","typeLabel":"string"},"cadence":{"type":"string","enum":["ONETIME","RECURRING"],"x-enum-varnames":["CreditGrantCadenceOneTime","CreditGrantCadenceRecurring"],"x-speakeasy-name-override":"CreditGrantCadence","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].cadence","typeLabel":"enum\u003cstring>"},"conversion_rate":{"type":"string","description":"amount in the currency = number of credits * conversion_rate\nex if conversion_rate is 1, then 1 USD = 1 credit\nex if conversion_rate is 2, then 1 USD = 0.5 credits\nex if conversion_rate is 0.5, then 1 USD = 2 credits","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].conversion_rate","typeLabel":"string"},"created_at":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].created_at","typeLabel":"string\u003cdate-time>"},"created_by":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].created_by","typeLabel":"string"},"credit_grant_anchor":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].credit_grant_anchor","typeLabel":"string\u003cdate-time>"},"credits":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].credits","typeLabel":"string"},"end_date":{"type":"string","format":"date-time","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].end_date","typeLabel":"string\u003cdate-time>"},"environment_id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].environment_id","typeLabel":"string"},"expiration_duration":{"type":"integer","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].expiration_duration","typeLabel":"integer"},"expiration_duration_unit":{"type":"string","enum":["DAY","WEEK","MONTH","YEAR"],"x-enum-varnames":["CreditGrantExpiryDurationUnitDays","CreditGrantExpiryDurationUnitWeeks","CreditGrantExpiryDurationUnitMonths","CreditGrantExpiryDurationUnitYears"],"x-speakeasy-name-override":"CreditGrantExpiryDurationUnit","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].expiration_duration_unit","typeLabel":"enum\u003cstring>"},"expiration_type":{"type":"string","enum":["NEVER","DURATION","BILLING_CYCLE"],"x-enum-varnames":["CreditGrantExpiryTypeNever","CreditGrantExpiryTypeDuration","CreditGrantExpiryTypeBillingCycle"],"x-speakeasy-name-override":"CreditGrantExpiryType","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].expiration_type","typeLabel":"enum\u003cstring>"},"id":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].id","typeLabel":"string"},"metadata":{"type":"object","additionalProperties":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].metadata.additionalProperties","typeLabel":"string"},"x-speakeasy-name-override":"Metadata","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].metadata","typeLabel":"object"},"name":{"type":"string","uniqueKey":"subscription.coupon_associations.items.[INDEX].subscription_line_item.price.addon.credit_grants.items.[INDEX].name","typeLabel":"string"},"period":{"type":"string","enum":["DAILY","WEEKLY","MONTHLY","ANNUAL","QUARTERLY","HALF_YEARLY"],"x-enum-varnames":["CREDIT_GRANT_PERIOD_DAILY","CREDIT_GRANT_PERIOD_WEEKLY","CREDIT_GRANT_PERIOD_MONTHLY","CREDIT_GRANT_PERIOD_ANNUAL","CREDIT_GRANT_PERIOD_QUARTER","CREDIT_GRANT_PERI
[...]
